parse source . . pgm
call directory filespec('L', pgm)
.local~my.fx=.directory~new
resources="resources"
signal on syntax
rexxHandler=.RexxAppHandler~new
rxApp=BSFCreateRexxProxy(rexxHandler, ,"javafx.application.Application")
rxApp~launch(rxApp~getClass, .nil)
call sysSleep 0.01
exit

syntax:
    co=condition("obj")
    say ppJavaExceptionChain(co)
    say
    raise propagate
  exit -1

::requires "BSF.CLS"
::requires UNO.CLS


::class RexxAppHandler
::method start
    use arg primaryStage

    primaryStage~setTitle("Ist die Vorlesung langweilig?")

    /* Klassen */
      colorClz=bsf.loadClass("javafx.scene.paint.Color")
      cdClz=bsf.loadClass("javafx.scene.control.ContentDisplay")
      alClz=bsf.loadClass("javafx.geometry.Pos")
      lblClz=bsf.import("javafx.scene.control.Label", "FX.Label")
      fontClz=bsf.loadClass("javafx.scene.text.Font")
      fontWeightClz=bsf.loadClass("javafx.scene.text.FontWeight")
      fontPostureClz=bsf.loadClass("javafx.scene.text.FontPosture")
      imageClz=bsf.loadClass("javafx.scene.image.ImageView")
      imageViewClz=bsf.loadClass("javafx.scene.image.Image")


    /* Anchor Pane */
      root=.bsf~new("javafx.scene.layout.AnchorPane")
      root~id="root"
      root~prefHeight=711
      root~prefWidth=711
      rootChildren=root~getChildren

    /* Hintegrund */
      backgroundImage = .bsf~new("javafx.scene.image.Image", resources"/BG.png")
      backgroundImageView = .bsf~new("javafx.scene.image.ImageView", backgroundImage)
      backgroundImageView~fitWidth = root~prefWidth
      backgroundImageView~fitHeight = root~prefHeight
      root~getChildren~add(backgroundImageView)

    /* Buttons */
      /*Schere*/
      btn1=.bsf~new("javafx.scene.control.Button")
      btn1~layoutX=514
      btn1~layoutY=25
      btn1~text="Schere"
      btn1~opacity = 0.0
      btn1~prefHeight = 200
      btn1~prefWidth = 150
      rootChildren~add(btn1)
      /*Papier*/
      btn2=.bsf~new("javafx.scene.control.Button")
      btn2~layoutX=55
      btn2~layoutY=25
      btn2~text="Papier"
      btn2~opacity = 0.0
      btn2~prefHeight = 200
      btn2~prefWidth = 150
      rootChildren~add(btn2)
      /*Stein*/
      btn3=.bsf~new("javafx.scene.control.Button")
      btn3~layoutX=280
      btn3~layoutY=25
      btn3~text="Stein"
      btn3~opacity = 0.0
      btn3~prefHeight = 200
      btn3~prefWidth = 150
      rootChildren~add(btn3)
      /*Reset*/
      btn4=.bsf~new("javafx.scene.control.Button")
      btn4~layoutX= 328
      btn4~layoutY=400
      btn4~text="RESET"
      btn4~opacity = 1
      btn4~prefHeight = 26
      btn4~prefWidth = 54.5
      rootChildren~add(btn4)
      /*Get Summary and end Game*/
      btn5=.bsf~new("javafx.scene.control.Button")
      btn5~layoutX= 290
      btn5~layoutY=370
      btn5~text="SUMMARY"
      btn5~opacity = 1
      btn5~prefHeight = 26
      btn5~prefWidth = 130.5
      rootChildren~add(btn5)

    /* Labels */
      /* Label Punkltestand Spieler*/
      lbl1=.bsf~new("javafx.scene.control.Label")
      lbl1~layoutX=90
      lbl1~layoutY=307
      lbl1~text="0"
      lbl1~setTextFill(colorClz~WHITE)
      lbl1~setFont(fontClz~font("Comic Sans MS", fontWeightClz~BOLD, 60))
      rootChildren~add(lbl1)
      /* Label Punkltestand PC*/
      lbl2=.bsf~new("javafx.scene.control.Label")
      lbl2~layoutX=590
      lbl2~layoutY=307
      lbl2~text="0"
      lbl2~setTextFill(colorClz~WHITE)
      lbl2~setFont(fontClz~font("Comic Sans MS", fontWeightClz~BOLD, 60))
      rootChildren~add(lbl2)
      /* Label Spieler */
      lbl3=.bsf~new("javafx.scene.control.Label")
      lbl3~layoutX=90
      lbl3~layoutY=275
      lbl3~text="DU"
      lbl3~setTextFill(colorClz~DARKGRAY)
      lbl3~setFont(fontClz~font("Comic Sans MS", fontWeightClz~BOLD, 30))
      rootChildren~add(lbl3)
      /* Label Spieler */
      lbl4=.bsf~new("javafx.scene.control.Label")
      lbl4~layoutX=590
      lbl4~layoutY=275
      lbl4~text="PC"
      lbl4~setTextFill(colorClz~DARKGRAY)
      lbl4~setFont(fontClz~font("Comic Sans MS", fontWeightClz~BOLD, 30))
      rootChildren~add(lbl4)
      /* Label VS */
      lbl5=.bsf~new("javafx.scene.control.Label")
      lbl5~layoutX= 341
      lbl5~layoutY=570
      lbl5~text="V S"
      lbl5~setTextFill(colorClz~RED)
      lbl5~alignment = alClz~CENTER
      lbl5~setFont(fontClz~font("Impact", fontWeightClz~BOLD, 40))
      rootChildren~add(lbl5)
      /* Label Auswahl Spieler */
      lbl6=.bsf~new("javafx.scene.control.Label")
      lbl6~layoutX= 90
      lbl6~layoutY= 400
      lbl6~text=""
      lbl6~setTextFill(colorClz~WHITE)
      lbl6~setFont(fontClz~font("Comic Sans MS", fontWeightClz~BOLD, 20))
      rootChildren~add(lbl6)
      /* Label Auswahl PC */
      lbl7=.bsf~new("javafx.scene.control.Label")
      lbl7~layoutX= 590
      lbl7~layoutY=400
      lbl7~text=""
      lbl7~setTextFill(colorClz~WHITE)
      lbl7~setFont(fontClz~font("Comic Sans MS", fontWeightClz~BOLD, 20))
      rootChildren~add(lbl7)
      /* Ergebnis */
      lbl8=.bsf~new("javafx.scene.control.Label")
      lbl8~layoutX= 270
      lbl8~layoutY= 307
      lbl8~text=""
      lbl8~contentDisplay = cdClz~CENTER       
      lbl8~alignment = alClz~CENTER
      lbl8~setTextFill(colorClz~WHITE)
      lbl8~setFont(fontClz~font("Impact", fontWeightClz~BOLD, 30))
      rootChildren~add(lbl8)


    /* Bilder */
      /*Benutzer*/
      imagePath1 = "resources/schere-stein-papier.jpg" /*"https://www.flaticon.com/de/kostenloses-icon/schere-stein-papier_6793710?term=schere+stein+papier&page=1&position=4&origin=tag&related_id=6793710"*/
      image1 = .bsf~new(imageViewClz, imagePath1)
      img1 = .bsf~new(imageClz)
      img1~setImage(image1)
      img1~fitHeight="150.0" 
      img1~fitWidth="200.0" 
      img1~layoutX="100.0" 
      img1~layoutY="525.0" 
      rootChildren~add(img1)
      /*PC*/
      imagePath2 = "resources/schere-stein-papier.jpg"
      image2 = .bsf~new(imageViewClz, imagePath2)
      img2 = .bsf~new(imageClz)
      img2~setImage(image2)
      img2~fitHeight="150.0" 
      img2~fitWidth="200.0" 
      img2~layoutX="411.0" 
      img2~layoutY="525.0" 
      rootChildren~add(img2)
      


    /* Buttonhandler */
      rh=.RexxButtonHandler~new(lbl1, lbl2, lbl6, lbl7, lbl8, img1, img2, btn5)
      jrh=BSFCreateRexxProxy(rh, ,"javafx.event.EventHandler")
      btn1~setOnAction(jrh)
      btn2~setOnAction(jrh)
      btn3~setOnAction(jrh)
      btn4~setOnAction(jrh)
      btn5~setOnAction(jrh)
      primaryStage~setScene(.bsf~new("javafx.scene.Scene", root))
      primaryStage~show

::class RexxButtonHandler
::method init
  expose lbl1 lbl2 lbl6 lbl7 lbl8 img1 img2 rootChildren btn4 btn5 xText
  use arg lbl1, lbl2, lbl6, lbl7, lbl8, img1, img2, rootChildren, btn4, btn5, xText

::method handle
  expose lbl1 lbl2 lbl6 lbl7 lbl8 img1 img2 rootChildren btn4 btn5 xText
  use arg event

  buttonText = event~getSource()~getText()
  lbl6~text = buttonText
  newImagePathUser = ""
  newImagePathPC = ""

  /* wenn Schere gewählt wird */
select
  when buttonText = "Schere" then do
    benutzer = 1
    newImagePathUser = "resources/schere.jpg"
    random = random(1,3)
    pcWahl = random
    select
      when pcWahl = 1 then do 
        newImagePathPC = "resources/schere.jpg"
        lbl7~text = "Schere"

      end
      when pcWahl = 2 then do
        newImagePathPC = "resources/papier.jpg"
        lbl7~text = "Papier"
      end
      when pcWahl = 3 then do
        newImagePathPC = "resources/stein.jpg"
        lbl7~text = "Stein"
      end
    end
    img1~setImage(.bsf~new("javafx.scene.image.Image", newImagePathUser))
    img2~setImage(.bsf~new("javafx.scene.image.Image", newImagePathPC))
    select
      when pcWahl = benutzer then do
        lbl8~text = " Unentschieden"
        spielStandPc=lbl2~getText()
        spielStandDU=lbl1~getText()
        text = "Unentschieden - Neuer Spielstand "spielStandPc " : "spielStandDU
      end
      when pcWahl = 3 & benutzer = 1 then do
        lbl8~text = "  PC gewinnt  "
        labeltext = lbl2~getText()
        lbl2~setText(labeltext + 1)
        spielStandPc=lbl2~getText()
        spielStandDU=lbl1~getText()
        text = "PC gewinnt - Neuer Spielstand "spielStandPC " : "spielStandDU   .DateTime~new
      end
      when pcWahl = 2 & benutzer = 1 then do
        lbl8~text = "  DU gewinnst "
        labeltext = lbl1~getText()
        lbl1~setText(labeltext + 1)
        spielStandPc=lbl2~getText()
        spielStandDU=lbl1~getText()
        text = "DU gewinnst - Neuer Spielstand "spielStandPC " : "spielStandDU   .DateTime~new
      end
    end
  end

/* wenn Papier gewählt wird */
  when buttonText = "Papier" then do
    benutzer = 2
    newImagePathUser = "resources/papier.jpg"
    random = random(1,3)
    pcWahl = random
    select
      when pcWahl = 1 then do 
        newImagePathPC = "resources/schere.jpg"
        lbl7~text = "Schere"
      end
      when pcWahl = 2 then do
        newImagePathPC = "resources/papier.jpg"
        lbl7~text = "Papier"
      end
      when pcWahl = 3 then do
        newImagePathPC = "resources/stein.jpg"
        lbl7~text = "Stein"
      end
    end
    img1~setImage(.bsf~new("javafx.scene.image.Image", newImagePathUser))
    img2~setImage(.bsf~new("javafx.scene.image.Image", newImagePathPC))
    select
      when pcWahl = benutzer then do
        lbl8~text = " Unentschieden"
        text = "Unentschieden - Neuer Spielstand "spielStandPc " : "spielStandDU
      end
      when pcWahl = 1 & benutzer = 2 then do
        lbl8~text = "  PC gewinnt  "
        labeltext = lbl2~getText()
        lbl2~setText(labeltext + 1)
        spielStandPc=lbl2~getText()
        spielStandDU=lbl1~getText()
        text = "PC gewinnt - Neuer Spielstand "spielStandPC " : "spielStandDU   .DateTime~new
      end
      when pcWahl = 3 & benutzer = 2 then do
        lbl8~text = "  DU gewinnst "
        labeltext = lbl1~getText()
        lbl1~setText(labeltext + 1)
        spielStandPc=lbl2~getText()
        spielStandDU=lbl1~getText()
        text = "DU gewinnst - Neuer Spielstand "spielStandPC " : "spielStandDU   .DateTime~new
      end
    end
  end

/* wenn Stein gewählt wird */
  when buttonText = "Stein" then do
    benutzer = 3
    newImagePathUser = "resources/stein.jpg"
    random = random(1,3)
    pcWahl = random
    select
      when pcWahl = 1 then do 
        newImagePathPC = "resources/schere.jpg"
        lbl7~text = "Schere"
      end
      when pcWahl = 2 then do
        newImagePathPC = "resources/papier.jpg"
        lbl7~text = "Papier"
      end
      when pcWahl = 3 then do
        newImagePathPC = "resources/stein.jpg"
        lbl7~text = "Stein"
      end
    end
    img1~setImage(.bsf~new("javafx.scene.image.Image", newImagePathUser))
    img2~setImage(.bsf~new("javafx.scene.image.Image", newImagePathPC))
    select
      when pcWahl = benutzer then do
        lbl8~text = " Unentschieden"
        text = "Unentschieden - Neuer Spielstand "spielStandPc " : "spielStandDU
      end
      when pcWahl = 2 & benutzer = 3 then do
        lbl8~text = "  PC gewinnt  "
        labeltext = lbl2~getText()
        lbl2~setText(labeltext + 1)
        spielStandPc=lbl2~getText()
        spielStandDU=lbl1~getText()
        text = "PC gewinnt - Neuer Spielstand "spielStandPC " : "spielStandDU   .DateTime~new
      end
      when pcWahl = 1 & benutzer = 3 then do
        lbl8~text = "  DU gewinnst "
        labeltext = lbl1~getText()
        lbl1~setText(labeltext + 1)
        spielStandPc=lbl2~getText()
        spielStandDU=lbl1~getText()
        text = "DU gewinnst - Neuer Spielstand "spielStandPC " : "spielStandDU   .DateTime~new
      end
    end
  end
  /*Reset Button*/
    when buttonText = "RESET" then do
    reset ="resources/schere-stein-papier.jpg"
    img1~setImage(.bsf~new("javafx.scene.image.Image", reset))
    img2~setImage(.bsf~new("javafx.scene.image.Image", reset))
    resetTextint = 0
    resetTextstr = "RESET"
    lbl1~setText(resetTextint)
    lbl2~setText(resetTextint)
    lbl6~setText(resetTextstr)
    lbl7~setText(resetTextstr)
    lbl8~setText("")
    end
  /* SUMMARY Button */
    when buttonText = "SUMMARY" then do
      PointDu = lbl1~getText()
      PointDu = PointDu + 0
      PointPC = lbl2~getText()
      PointPC = PointPC + 0
      summaryText = "Summary"
      lbl6~setText(summaryText)
      lbl7~setText(summaryText)
      select 
        when PointDu > PointPC then do
          lbl8~setText("DU hast gewonnen")
          summaryImg = "resources/party.jpg"
        end
        when PointDu < PointPC then do
          lbl8~setText("DU hast verloren")
          summaryImg = "resources/sad.jpg"
        end
        when PointDu = PointPC then do
          lbl8~setText("unentschieden")
          summaryImg = "resources/draw.jpg"
        end
      end
      img1~setImage(.bsf~new("javafx.scene.image.Image", summaryImg))
      img2~setImage(.bsf~new("javafx.scene.image.Image", summaryImg))

      /* Add UNO code to write to LibreOffice Writer */
      xDesktop= UNO.createDesktop() 
      xComponentLoader = xDesktop~XComponentLoader 
      url = "private:factory/swriter"
      writerComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .UNO~noProps)
      xText = writerComponent~XTextDocument~getText
      xTextCursor = xText~createTextCursor
      xParaProps=xTextCursor~XParagraphCursor~XPropertySet
      ctlChars=.uno_constants~new("com.sun.star.text.ControlCharacter") 
      paraBreak=ctlChars~paragraph_break  
      paraAdj =.uno_enum~new("com.sun.star.style.ParagraphAdjust")
      xTextCursorProps = xTextCursor~XPropertySet
      xTextProps = xTextCursor~XPropertySet 
      xParaProps~setPropertyValue("ParaAdjust", paraAdj~send("center"))
      xTextProps~setPropertyValue("CharFontName", "Arial Black")
      xTextProps~setPropertyValue("CharHeight", 30)
      xText~setString("Spielende")
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xTextProps~setPropertyValue("CharFontName", "Verdana")
      xTextProps~setPropertyValue("CharHeight", 10)
      xText~insertString(xTextCursor, "-----------------------------------------------------------------------------", .true)
      xTextCursor~gotoEnd(.false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xTextProps~setPropertyValue("CharFontName", "Charmonman")
      xTextProps~setPropertyValue("CharWeight", 150)
      xTextProps~setPropertyValue("CharHeight", 28)
      ergebnisNum = PointDu "  -  " PointPc
      xtext~insertString(xTextCursor, ergebnisNum, .true)
      xTextCursor~gotoEnd(.false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)

      ergebnisText = ""
        select
          when PointDu > PointPC then ergebnisText = "Gratulation du hast Gewonnen "
          when PointDu = PointPC then ergebnisText = "Naja... immerhin nicht verloren"
          when PointDu < PointPC then ergebnisText = "Dein ernst? Das kannst du besser"
        end

      xTextProps~setPropertyValue("CharWeight", 125)
      xTextProps~setPropertyValue("CharHeight", 24)
      xText~insertString(xTextCursor, ergebnisText, .true)
      xTextCursor~gotoEnd(.false)
      xTextProps~setPropertyValue("CharFontName", "Verdana")
      xTextProps~setPropertyValue("CharHeight", 10)
      xTextCursor~gotoEnd(.false)
      xTextProps~setPropertyValue("CharWeight", 100)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xText~insertString(xTextCursor, "-----------------------------------------------------------------------------", .true)
      xTextCursor~gotoEnd(.false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xText~insertControlCharacter(xTextCursor, paraBreak, .false)
      xTextProps~setPropertyValue("CharFontName", "Verdana")  
      xTextProps~setPropertyValue("CharHeight", 10)
      xTextProps~setPropertyValue("CharWeight", 100)
      datetime = .DateTime~new
      parse var datetime  datePart "T" timePart
      parse var datePart year "-" month "-" day
      parse var timePart hour ":" minute ":" second "." millisecond
      endString = "Spiel: Schere/Stein/Papier - gespielt am " day"/"month"/"year", abgeschlossen um " hour":"minute
      xText~insertString(xTextCursor, endString, .true)

    end
end